;
; ADC-Test demonstrates Studio
;
;Verwendete Ressourcen:
;* Timer0-berlauf-Interrupt alle 10ms fr:
;  - Tastenentprellung

.nolist
.include "m1280def.inc"					;Konfigurationsdatei fr Controller
.include "Definitionen.inc"
.list
;
;ist diese Zeile NICHT ausgeblendet, werden Teile des Programms bersprungen
;.equ debug  = 1							

;Byte-Reservierung im SRAM

.dseg
;.org SRAM_START
;.org 0x2000
Disp_Stat:	.byte 2					;Displaystatus -> 1.Byte= neue Anzeige / 2.Byte= alte Anzeige
Ventil: 	.byte 1
Dauer:		.byte 1
Absenk:		.byte 1
Channel:	.byte 1

St_Name:	.byte 9
St_ist:		.byte 5
St_N:		.byte 5
St_A:		.byte 5
St_D:		.byte 5

Sl_Name:	.byte 9
Sl_ist:		.byte 5
Sl_N:		.byte 5
Sl_A:		.byte 5
Sl_D:		.byte 5

Ba_Name:	.byte 9
Ba_ist:		.byte 5
Ba_N:		.byte 5
Ba_A:		.byte 5
Ba_D:		.byte 5

Ku_Name:	.byte 9
Ku_ist:		.byte 5
Ku_N:		.byte 5
Ku_A:		.byte 5
Ku_D:		.byte 5

Ra_Name:	.byte 9
Ra_ist:		.byte 5
Ra_N:		.byte 5
Ra_A:		.byte 5
Ra_D:		.byte 5

Li_Name:	.byte 9
Li_ist:		.byte 5
Li_N:		.byte 5
Li_A:		.byte 5
Li_D:		.byte 5

Du_Name:	.byte 9
Du_ist:		.byte 5
Du_N:		.byte 5
Du_A:		.byte 5
Du_D:		.byte 5

Au_Name:	.byte 9
Au_ist:		.byte 5
Au_N:		.byte 5
Au_A:		.byte 5
Au_D:		.byte 5




;Hier beginnt das Programm - mit den Interrupt-Sprungadressen...
.cseg               	;Codesegment (Programmcode, Flash)
.org 0x0000              	;Startadresse 0

;Zuerst (an Adresse 0) kommt immer der Sprung zur Reset-Routine.
;Danach kommen die Interrupt-Vektoren in der Reihenfolge, wie sie im
;Datenblatt des jeweiligen AVRs angegeben sind.
;Nicht benutzte Interrupts bentigen Dummy-Befehle als Platzhalter, damit
;die Adressen nicht durcheinander geraten. Nimmt man als Dummy den Befehl
;"reti", so bewikt ein versehentlich ausgelster Interrupt
;(Programmierfehler) einen sofortigen sauberen Rcksprung ohne Stackfehler.

jmp RESET 				; Reset Handler
;nop
reti;jmp INT0 				; IRQ0 Handler
nop
reti;jmp INT1 				; IRQ1 Handler
nop
reti;jmp INT2 				; IRQ2 Handler
nop
reti;jmp INT3 				; IRQ3 Handler
nop
reti;jmp INT4 				; IRQ4 Handler
nop
reti;jmp INT5 				; IRQ5 Handler
nop
reti;jmp INT6 				; IRQ6 Handler
nop
reti;jmp INT7 				; IRQ7 Handler
nop
reti;jmp PCINT0 			; PCINT0 Handler
nop
reti;jmp PCINT1 			; PCINT1 Handler
nop
reti;jmp PCINT2 			; PCINT2 Handler
nop
reti;jmp WDT 				; Watchdog Timeout Handler
nop
reti;jmp TIM2_COMPA 		; Timer2 CompareA Handler
nop
reti;jmp TIM2_COMPB 		; Timer2 CompareB Handler
nop
reti;jmp TIM2_OVF 			; Timer2 Overflow Handler
nop
reti;jmp TIM1_CAPT 			; Timer1 Capture Handler
nop
reti;jmp TIM1_COMPA 		; Timer1 CompareA Handler
nop
reti;jmp TIM1_COMPB 		; Timer1 CompareB Handler
nop
reti;jmp TIM1_COMPC 		; Timer1 CompareC Handler
nop
reti;jmp TIM1_OVF 			; Timer1 Overflow Handler
nop
reti;jmp TIM0_COMPA 		; Timer0 CompareA Handler
nop
reti;jmp TIM0_COMPB 		; Timer0 CompareB Handler
nop
jmp TIM0_OVF 			; Timer0 Overflow Handler
;nop
reti;jmp SPI_STC 			; SPI Transfer Complete Handler
nop
reti;jmp USART0_RXC 		; USART0 RX Complete Handler
nop
reti;jmp USART0_UDRE 		; USART0,UDR Empty Handler
nop
reti;jmp USART0_TXC 		; USART0 TX Complete Handler
nop
reti;jmp ANA_COMP 			; Analog Comparator Handler
nop
reti;jmp ADC 				; ADC Conversion Complete Handler
nop
reti;jmp EE_RDY 			; EEPROM Ready Handler
nop
reti;jmp TIM3_CAPT 			; Timer3 Capture Handler
nop
reti;jmp TIM3_COMPA 		; Timer3 CompareA Handler
nop
reti;jmp TIM3_COMPB 		; Timer3 CompareB Handler
nop
reti;jmp TIM3_COMPC 		; Timer3 CompareC Handler
nop
reti;jmp TIM3_OVF 			; Timer3 Overflow Handler
nop
reti;jmp USART1_RXC 		; USART1 RX Complete Handler
nop
reti;jmp USART1_UDRE 		; USART1,UDR Empty Handler
nop
reti;jmp USART1_TXC 		; USART1 TX Complete Handler
nop
reti;jmp TWI 				; 2-wire Serial Handler
nop
reti;jmp SPM_RDY 			; SPM Ready Handler
nop
reti;jmp TIM4_CAPT 			; Timer4 Capture Handler
nop
reti;jmp TIM4_COMPA 		; Timer4 CompareA Handler
nop
reti;jmp TIM4_COMPB 		; Timer4 CompareB Handler
nop
reti;jmp TIM4_COMPC 		; Timer4 CompareC Handler
nop
reti;jmp TIM4_OVF 			; Timer4 Overflow Handler
nop
reti;jmp TIM5_CAPT 			; Timer5 Capture Handler
nop
reti;jmp TIM5_COMPA 		; Timer5 CompareA Handler
nop
reti;jmp TIM5_COMPB 		; Timer5 CompareB Handler
nop
reti;jmp TIM5_COMPC 		; Timer5 CompareC Handler
nop
reti;jmp TIM5_OVF 			; Timer5 Overflow Handler
nop
reti;jmp USART2_RXC 		; USART2 RX Complete Handler
nop
reti;jmp USART2_UDRE 		; USART2,UDR Empty Handler
nop
reti;jmp USART2_TXC 		; USART2 TX Complete Handler
nop
reti;jmp USART3_RXC 		; USART3 RX Complete Handler
nop
reti;jmp USART3_UDRE 		; USART3,UDR Empty Handler
nop
reti;jmp USART3_TXC 		; USART3 TX Complete Handler
nop

; Interruptdefinition abgeschlossen

; Include-Dateien fr Routinen
.include "ISR.asm"						;ISR-Routinen werden hier eingefgt
.include "set-Ports.asm"				;Set-Ports werden hier eingefgt
.include "Sram-routines.asm"			;Sram-Routinen werden hier eingefgt
.include "lcd-routines.asm"				;LCD-Routinen werden hier eingefgt
.include "adc-routines.asm"				;ADC-Routinen werden hier eingefgt
.include "LCD-MENU.asm"					;LCD-Menu wird hier eingefgt
.include "UHR.asm"						;integriert interne Uhr

;Hier beginnt der Programmteil, der beim Einschalten aufgerufen wird.
RESET:

;
;Stapel initialisieren   
	LDI 	temp1,HIGH(ramend) 		; Oberes Byte
	OUT		SPH,temp1
	LDI 	temp1,LOW(ramend)		; Unteres Byte
    OUT 	SPL,temp1 				; an Stapelzeiger senden  
	  
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms
;	call	delay100ms


;verschiedene Strings in den SRAM laden
	call	Store_Au_Name			;Name Aussen in den SRAM laden
	call	Store_St_Name			;Name Stube in den SRAM laden
	call	Store_Sl_Name			;Name Slazi in den SRAM laden
	call	Store_Ba_Name			;Name Bad in den SRAM laden
	call	Store_Ku_Name			;Name Kueche in den SRAM laden
	call	Store_Ra_Name			;Name Ralph in den SRAM laden
	call	Store_Li_Name			;Name Lisa in den SRAM laden
	call	Store_Du_Name			;Name Dusche in den SRAM laden


;Display, ADC und Ports initialisieren

	call 	adc_init				;ADC initialisieren
	call 	set_Ports				;Ports setzen
	call 	set_tasten				;Ports fr Tasten werden gesetzt
	call 	lcd_init     			;Display initialisieren
	call 	lcd_clear    			;Display lschen
;	call	delay100ms

;Timer0 erzeugt mittels berlauf-Interrupt den Steuertakt von 1ms.
 	ldi 	temp1,256-zaehlumfang	;Startwert (Reload) fr Timer0
	mov 	tsw,temp1          		;einrichten und
	out 	TCNT0,tsw              	;setzen
	ldi 	temp1,3                 ;Vorteiler 64 (DB Seite 132)
	out 	TCCR0B,temp1            ;fr Timer0
	ldi 	temp1,1<<TOIE0          ;Timer0-berlauf-Interrupt
	sts 	TIMSK0,temp1            ;aktivieren

;+++++++++++++++++++++++++++++ ist noch nicht aktiv - wird von acd oder Zeit-Interrupt aufgeweckt +++++++++++++++++++++
;Damit der Controller nicht unntig herumtrollt, wird er nach getaner
;Arbeit in den Sleep-Mode geschickt. Damit das funktioniert, muss der
;Sleep-Mode erstmal freigeschaltet werden:
;	ldi 	temp1,1<<SE             ;Sleep-Mode
;	out 	SMCR,temp1              ;freischalten

;Die Tastenentprellung (bernahme erst nach 4 stabilen Scans) erwartet
;definierte Anfangsbedingungen. Diese werden hier geschaffen. Die beiden
;Prellzhler werden auf H gesetzt, Status und Flag auf L:
	ser 	temp1
	mov 	tz0,temp1				;stabile
	mov 	tz1,temp1				;Start-
	clr 	tas						;Bedingungen
	clr 	tfl						;herstellen
;  Die Uhr auf 0 setzen
        clr     Minuten             
        clr     Sekunden
        clr     Stunden
        clr     SubCount



;bei Programmstart bzw nach Reset erste Displayseite laden
	ldi		YL,LOW(Disp_Stat)		;Zeiger fr Displaystatus-Bytes in den Zeiger laden
	ldi		YH,HIGH(Disp_Stat)
	ldi		temp2,-1				;Zhler fr Display-Status auf -1 setzen, weil 1 addiert wird (Seite 0 anzeigen)
	st		Y,temp2					;Zhler fr neue Anzeige in den Sram laden
	std		Y+1,temp2				;Zhler fr alte Anzeige in den Sram laden
	ldi		temp2,0
	call	Menu_Change			;Menu laden und an Display ausgeben

;Damit der Timer den Interrupt auslsen kann, mssen Interrupts global
;freigeschaltet werden (i-Flag in SREG):
	sei								;Interrupts global freigeben

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;Die Hauptschleife des Programms. Hier werden (nach jedem Timer0-Interrupt)
;die Tastenflags abgefragt, solange keine Melodieausgabe luft (busy).
;Die Tastenflags werden durch die Entprellroutine (in der ISR) gesetzt, wenn
;eine Taste lnger als 4 Abfragen lang stabil bettigt war. Sind alle Tasten-
;Flags abgefragt, geht der MC in den Sleep-Mode, bis er vom nchsten
;Interrupt wieder geweckt wird.

mainloop:           				;Hauptschleife
; 	sbrc 	tfl,busy              		;Test des Busy-Flag fr Sperrung der Tastenabfrage wenn wichtige Ausgaben gemacht werden
; 	rjmp 	mainloop1             		;ja, BusyFlag gesetzt -> keine Tasten auswerten...
;        sbrs    tfl,7
;        brne    weiter                ; Flag im Interrupt gesetzt?
;        cbr		tfl,7                ; flag lschen
;        call   lcd_uhr           ; Uhr an das LCD ausgeben
weiter:
	call 	adc_abfragen				;hier ADC abfragen -> muss noch gendert werden fr alle Kanle abfragen
	call	Temp_akt
 	sbrc 	tfl,t1                		;Taste 1 bettigt gewesen? - nein...
 	call 	taste1                		;ja, abarbeiten...
 	sbrc 	tfl,t2                		;Taste 2 bettigt gewesen? - nein...
 	call 	taste2                		;ja, abarbeiten...
 	sbrc 	tfl,t3                		;Taste 3 bettigt gewesen? - nein...
 	call 	taste3                		;ja, abarbeiten...
 	sbrc 	tfl,t4                		;Taste 4 bettigt gewesen? - nein...
 	call 	taste4                		;ja, abarbeiten...
mainloop1:
; 	sleep  	                    		;bis zum nchsten Interrupt schlafen
 	jmp 	mainloop              		;nochmal Hauptschleife ausfhren


;Wurde eine Taste bettigt, so wird in eine der hier folgenden Routinen
;verzweigt. Hier wird das Tastenflag gelscht (denn der "Job" wird ja nun
;ausgefhrt), der Z-Pointer auf den Anfang der zur Taste gehrenden Tabelle
;mit Sounddaten positioniert und zum Start der Soundausgabe gesprungen:
taste1:             ;Taste 1 wurde bettigt
 	cbr		tfl,1<<t1           ;Tastenflag lschen
 	call 	Menu_Change			;gehe zur Routine -> Display umschalten
	ret
; 	jmp		mainloop			;und zum Hauptprogramm zurck

taste2:             ;Taste 2 wurde bettigt
 	cbr 	tfl,1<<t2           ;Tastenflag lschen
; 	ldi 	zl,low(sound2*2)    ;Pointer auf Anfang
; 	ldi 	zh,high(sound2*2)   ;Sounddatenliste setzen
	ret
; 	jmp		mainloop			;und zum Hauptprogramm zurck

taste3:             ;Taste 3 wurde bettigt
 	cbr 	tfl,1<<t3           ;Tastenflag lschen
;	ldi 	zl,low(sound3*2)    ;Pointer auf Anfang
; 	ldi 	zh,high(sound3*2)   ;Sounddatenliste setzen
	ret
; 	rjmp	mainloop			;und zum Hauptprogramm zurck

taste4:             ;Taste 4 wurde bettigt
 	cbr 	tfl,1<<t4           ;Tastenflag lschen
; 	ldi 	zl,low(sound4*2)    ;Pointer auf Anfang
; 	ldi 	zh,high(sound4*2)   ;Sounddatenliste setzen
 	ret
;	rjmp	mainloop			;und zum Hauptprogramm zurck





;.cseg
;.org 0x1000

;Textdefinitionen
;
;Stringkonstanten sollten eine gerade Zeichenanzahl haben und durch eine 0 abgeschlossen sein (diese wird mit gezhlt) 
;
;;;;"0123456789ABCDEF""0123456789ABCDEF""0123456789ABCDEF""0123456789ABCDEF",0,0		;max 64 zeichen (4x16)
Startbildschirm:	
	.db "STARTBILDSCHIRM ""Heizungsregelung ",0		;String fr den Begrungsbildschirm

Stube:	.db	"Stube:   ",0					;Namen der Zimmer zum laden in den Sram -> spter vielleicht mal aus EEPROM
Slazi:	.db	"Slazi:   ",0
Bad:	.db	"Bad:     ",0
Kuche:	.db "Kueche:  ",0
Ralph:	.db "Ralph:   ",0
Lisa:	.db "Lisa:    ",0
Dusche:	.db "Dusche:  ",0
Aussen:	.db "Aussen:  ",0

Ch_Tab: .dw Au_Name,St_Name,Sl_Name,Ba_Name,Ku_Name,Ra_Name,Li_Name,Du_Name

