; Definitionsdatei
;
.ifndef XTAL
.equ XTAL = 16000000					;Taktfrequenz des Prozessors
.endif


; allgemeine Registerdefinitionen

;untere (dumme) Register -> keine Konstanten mglich
;.def		=r0 		;kann fr LPM benutzt werden, bekommt aber keinen Alias-Namen
;.def		=r1			;wird momentan nicht benutzt
.def srsk	=r2        	;Kopie SREG whrend ISR
.def tsw	=r3         ;Startwert Timer0
.def tz0	=r4         ;Tasten-Prellzhler Bit 0
.def tz1	=r5         ;Tasten-Prellzhler Bit 1
.def tas	=r6         ;Tasten-Status (entprellt)
;.def 		=r7      	;wird momentan nicht benutzt
;.def 		=r8      	;wird momentan nicht benutzt
;.def		=r9			;wird momentan nicht benutzt
.def SubCount	=r10		;wird momentan nicht benutzt
.def Sekunden	=r11		;wird momentan nicht benutzt
.def Minuten	=r12		;wird momentan nicht benutzt
.def Stunden	=r13		;wird momentan nicht benutzt
;.def		=r14		;wird momentan nicht benutzt
;.def		=r15		;wird momentan nicht benutzt

;obere (wertvollere) Register -> Konstanten mglich
.def temp1	=r16		;Universalregister1
.def temp2	=r17		;Universalregister2
.def temp3	=r18		;Universalregister3
.def temp4	=r19		;Universalregister4
.def ch		=r20        ;Channel - Kanal, der gerade bearbeitet wird
.def tfl	=r21        ;Tastenflags (neu gedrckte Tasten) -> zur Abarbeitung im Programm
.def trL	=r22		;Low-Transportregister - zum Transport von 16-bit-Daten
.def trH	=r23		;High-Transportregister - zum Transport von 16-bit-Daten
.def wL		=r24        ;Working low (temp)
.def wH		=r25        ;Working high (temp)
;XH:XL 		=r27:r26	;wird momentan nicht benutzt			deklariert in "m1280def.inc"
;YH:YL 		=r29:r28	;wird als Pointer fr SRAM  genutzt, 	deklariert in "m1280def.inc"
;ZH:ZL 		=r31:r30	;wird als Pointer fr FLASH genutzt, 	deklariert in "m1280def.inc"


; Definitionen fr ADC

.equ Zaehler	=10						;Zhlschleife setzen (Anzahl der Messungen)
.equ Pot_Div	=3						;Divisor Setzen - Anzahl der "Rechtsschiebungen" (Divisionen /2)
.equ Maxwert	=(1023*Zaehler)/(2*2*2)
.equ Schritt	=(Maxwert/1023)
;
.equ offset		=361					;temperatur nach unten korrigieren (128C - 38 = 90C) mit Faktor 10
.equ Obergrenze	=(Maxwert-(11*Schritt))					;die nchsten 4 Grenzwerte fr ADC-Test
.equ Mitte		=(11*Schritt)
.equ Untergrenze=(Schritt)
.equ null		=0

; Definitionen fr Menu
.equ Max_Seite	=2		;Anzahl der maximalen Displayseiten (+1 -> fngt bei 0 an)

;Der Tiny15 luft mit 1,6MHz wenn der interne RC-Oszillator korrekt
;kalibriert wird. Fr die Tondauersteuerung wird ein stabiles Zeitnormal
;bentigt. Um den vollen Wertebereich eines Bytes ausnutzen zu knnen,
;wird ein Interrupt-Takt von 100Hz (10ms) angestrebt. Das ergibt Tondauern
;bis maximal 2,55 Sekunden. Mit Timer0-Vorteiler von 64 und einem Zhlumfang
;von 250 wird die Interruptfolge von 10ms erreicht.
.equ zaehlumfang=250    	;Timer0-Zhlumfang

;Definition des Ports, an dem die Tasten angeschlossen sind. Im Falle des
;Tiny15 nicht unbedingt erforderlich, bei anderen AVRs aber sehr ntzlich.
.equ tap	=pina           ;Eingang Tastenport

;Definition der Bits, die die 4 Taster reprsentieren:
.equ t1		=0            ;Taster 1
.equ t2		=1            ;Taster 2
.equ t3		=2            ;Taster 3
.equ t4		=3            ;Taster 4
;Whrend eine Melodie abgespielt wird, darf keine weitere Melodie begonnen
;werden. Zu diesem Zweck gibt es das Sperrflag "busy", welches die Abfrage
;der Tastendrcke unterdrckt. Da im Tastenflag-Register noch freie Bits
;verfgbar sind, wird das Sperrflag dort gefhrt.
.equ busy=7             ;Busy-Flag in Register tfl

;

; Achtung doppelt definiert ++++++++++++++++++++++++++++++++++++++++

; I/OPorts setzen
;.EQU I			=PinB					;		Input-Register setzen (Pin-Register von PortB)
;.EQU Display	=0						;(D53)	Input-Bit fr "Stube" setzen (Bit 0)
.EQU A			=PortB					;		Ausgangs-Port setzen (Port B)
.EQU ledrot		=7						;(D13)	Bit fr rote LED setzen
.EQU ledgelb	=6						;(D12)	Bit fr gelbe LED setzen
.EQU ledgruen	=5						;(D11)	Bit fr grne LED setzen

; diverse Variablen setzen
.equ	Max_Ch		=8
.equ	Bit_Stube	=0
.equ	Bit_Slazi	=1
.equ	Bit_Bad		=2
.equ	Bit_Kuche	=3
.equ	Bit_Ralph	=4
.equ	Bit_Lisa	=5
.equ	Bit_Dusche	=6
.equ	Bit_Aussen	=7

.equ	ist	=9
.equ	nor =14
;.equ	abs =19
.equ	dau =24

; Definitionen fr LCD

.equ LCD_PORT 	= PORTC
.equ LCD_DDR  	= DDRC
.equ PIN_RS   	= 4
.equ PIN_E    	= 5

.equ lcd_start	= 0b10000000			;Startadresse Display
.equ zeile1   	= 0x80+2				;Startadresse 1.Zeile
.equ zeile2   	= 0xC0+2				;Startadresse 2.Zeile
.equ zeile3   	= 0x90+2				;Startadresse 3.Zeile
.equ zeile4   	= 0xD0+2				;Startadresse 4.Zeile






