;
;Sammlung von ISRs (Interrupt-Service-Routinen)
;
;
;ISR, die bei berlauf des Timer0 ausgelst wird:
;
TIM0_OVF:           ;ISR Timer0-berlauf
	push	temp1
 	in 		srsk,SREG   		;Statusregister sichern
	push	srsk

 	out 	TCNT0,tsw  			;Timer Reload (Startwert setzen)
Tastenabfrage:  	;Entprellroutine (geklaut bei Peter Dannegger...)
 	in 		temp1,tap      		;Tastenport einlesen (gedrckt=L)
 	com 	temp1         		;invertieren (gedrckt=H)
; 	cbr 	temp1,$F0     		;obere vier Bits ausblenden (eigene Modifikation)
 	eor 	temp1,tas     		;nur nderungen werden H
 	and 	tz0,temp1     		;Prellzhler unvernderter Tasten lschen (Bit0)
 	and 	tz1,temp1     		;Prellzhler unvernderter Tasten lschen (Bit1)
 	com 	tz0        			;L-Bit zhlen 0,2,->1, 1,3,->0
 	eor 	tz1,tz0    			;H-Bit zhlen 0,2,->tz1 toggeln
 	and 	temp1,tz0     		;nderungen nur dann erhalten, wenn im Prellzhler
 	and 	temp1,tz1     		;beide Bits gesetzt sind (Zhlerstand 3)
 	eor 	tas,temp1     		;erhaltene nderungen toggeln alten (gltigen) Tastenstatus
 	and 	temp1,tas     		;nur (neu) gedrckte Tastenbits bleiben erhalten
 	or 		tfl,temp1      		;und zugehrige Bits setzen (gelscht wird nach Abarbeitung)
 				;in "tas" steht jetzt der gltige Tastenzustand,
 				;in "tfl" die Flags der neu gedrckten, noch nicht abgearbeiteten Tasten...
 				;temp1 ist jetzt wieder frei fr weitere temporre Zwecke in der ISR
		ldi		temp1,0
        inc     SubCount            ; Wenn dies nicht der 100. Interrupt   		
		mov		temp1,subcount     
        cpi     temp1, 100	        ; ist, dann passiert gar nichts
		brne    tim0_ende
;	call 	uhr

tim0_ende:
	pop		srsk
 	out 	sreg,srsk          	;Statusregister wiederherstellen
	pop		temp1
 	reti                       	;fertig...


.ifdef nix
;++++++++++++++++++++++++++++++++ eventuell in Zukunft diese Routine verwenden +++++++++++++++++++++++++++
;die knnte auch die Zeit messen, oder das Taster loslassen benutzen zum schalten


Tastenabfrage:  				;Entprell-Algorithmus geklaut bei Peter Dannegger...
 	cbr 	flags,1<<entprell 	;Jobflag lschen
 	in 		temp1,tap         	;Tastenport einlesen (gedrckt=L)
 	com 	temp1            	;invertieren (gedrckt=H)
 	andi 	temp1,alltast   	;ungenutzte Bits ausblenden
 	eor 	temp1,tas        	;nur nderungen werden H
 	and 	tz0,temp1        	;Prellzhler unvernderter Tasten lschen (Bit0)
 	and 	tz1,temp1        	;Prellzhler unvernderter Tasten lschen (Bit1)
 	com 	tz0            		;L-Bit zhlen 0,2,->1, 1,3,->0
 	eor 	tz1,tz0        		;H-Bit zhlen 0,2,->tz1 toggeln
 	and 	temp1,tz0        	;nderungen nur dann erhalten, wenn im Prellzhler
 	and 	temp1,tz1        	;beide Bits gesetzt sind (Zhlerstand 3)
; Loslasserkennung in diesem Programm deaktiviert
; 	push 	temp1           	;Kopie
; 	and 	temp1,tas        	;nur die Tasten erhalten, die jetzt losgelassen wurden
; 	swap 	temp1           	;ins andere Nibble (das ist ja frei)
; 	or 		tfl,temp1         	;Bits im anderen Nibble setzen (alternativ)
; 	or 		tlf,temp1         	;Bits im anderen Register setzen (alternativ)
; 	pop 	temp1            	;alten Wert
 	eor 	tas,temp1        	;erhaltene nderungen toggeln alten (gltigen) Tastenstatus
 	and 	temp1,tas        	;nur (neu) gedrckte Tastenbits bleiben erhalten
 	or 		tfl,temp1         	;und zugehrige Bits setzen (gelscht wird nach Abarbeitung)
 					;in "tas" steht jetzt der gltige Tastenzustand,
 					;in "tfl" die Flags der neu gedrckten, noch nicht abgearbeiteten Tasten...
Tastendauer:
 	mov 	temp1,tas        	;Tastenzustand kopieren
 	andi 	temp1,wietast   	;nur Tasten mit Wiederholfunktion stehen lassen
 	tst 	temp1            	;ist eine Taste bettigt?
 	breq 	Tastendauer0  		;nein, Dauer auf Startwert...
 	dec 	twz            		;ja, Zhler runter
 	brne 	Tastenabfrage_e   	;Dauer abgelaufen? - nein...
 	or 		tfl,temp1         	;ja, noch aktive Tasten bernehmen (alternativ)
; 	or 		twf,temp1         	;ja, noch aktive Tasten bernehmen (alternativ)
	ldi 	twz,twz1       		;und Zhler auf Wiederholwert setzen
Tastenabfrage_e:
.endif





