; Routinen zum Speichern und Abrufen im Sram

;Store_Sram_Namen:
;	ldi 	ZL, LOW(Stube*2)         ; Adresse des Strings in den
;  	ldi 	ZH, HIGH(Stube*2)        ; Z-Pointer laden
;	ldi		YL, LOW(St_Name)
;	ldi		YH, HIGH(St_Name)
;	rcall 	Load_SRAM
;	ret

Store_St_Name:
	ldi 	ZL, LOW(Stube*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Stube*2)        ; Z-Pointer laden
	ldi		YL, LOW(St_Name)
	ldi		YH, HIGH(St_Name)
	call 	Load_SRAM
	ret

Store_Sl_Name:
	ldi 	ZL, LOW(Slazi*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Slazi*2)        ; Z-Pointer laden
	ldi		YL, LOW(Sl_Name)
	ldi		YH, HIGH(Sl_Name)
	call 	Load_SRAM
	ret

Store_Ba_Name:
	ldi 	ZL, LOW(Bad*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Bad*2)        ; Z-Pointer laden
	ldi		YL, LOW(Ba_Name)
	ldi		YH, HIGH(Ba_Name)
	call 	Load_SRAM
	ret

Store_Ku_Name:
	ldi 	ZL, LOW(Kuche*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Kuche*2)        ; Z-Pointer laden
	ldi		YL, LOW(Ku_Name)
	ldi		YH, HIGH(Ku_Name)
	call 	Load_SRAM
	ret

Store_Ra_Name:
	ldi 	ZL, LOW(Ralph*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Ralph*2)        ; Z-Pointer laden
	ldi		YL, LOW(Ra_Name)
	ldi		YH, HIGH(Ra_Name)
	call 	Load_SRAM
	ret

Store_Li_Name:
	ldi 	ZL, LOW(Lisa*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Lisa*2)        ; Z-Pointer laden
	ldi		YL, LOW(Li_Name)
	ldi		YH, HIGH(Li_Name)
	call 	Load_SRAM
	ret

Store_Du_Name:
	ldi 	ZL, LOW(Dusche*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Dusche*2)        ; Z-Pointer laden
	ldi		YL, LOW(Du_Name)
	ldi		YH, HIGH(Du_Name)
	call 	Load_SRAM
	ret

Store_Au_Name:
	ldi 	ZL, LOW(Aussen*2)         ; Adresse des Strings in den
   	ldi 	ZH, HIGH(Aussen*2)        ; Z-Pointer laden
	ldi		YL, LOW(Au_Name)
	ldi		YH, HIGH(Au_Name)
	call 	Load_SRAM
	ret

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; laden eines Strings in den SRAM
Load_SRAM:
	push	temp1
	in		srsk,sreg
	push	srsk
Load_SRAM_0:
	ldi		temp1,0
	lpm		temp1,Z+				; geht nur im Flash -> liest Zeichen aus dem Flash
	st		Y+,temp1				; Schreibt dieses Zeichen an die Adresse im Sram, auf die der Y-Zeiger zeigt und erhht Zeiger um 1
	cpi		temp1,0					; prft, ob Zeichen eine 0 ist
	breq	Load_SRAM_1				; wenn ja, gehe zum Label am ende der Schleife
	jmp		Load_SRAM_0				; wenn nicht, gehe zum Anfang der Schleife fr nchstes Zeichen
Load_SRAM_1:

	pop		srsk
	out		sreg,srsk
	pop		temp1
	ret

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


;Eine 16-Bit-Zahl aus dem Register temp1:temp2 mit Vorzeichen dezimal ausgeben
;bentigt 7 Zeichen (inkl. Vorzeichen und 1 Festkommastelle)
lcd_number_Sram:
	push	temp1							;sichere auf Stack
	push	temp2							;sichere auf Stack
	push	temp3							;sichere auf Stack
	push	temp4							;sichere auf Stack
	push	wL								;sichere auf Stack
	push	wH								;sichere auf Stack
	in		srsk,SREG						;sichere SREG in Hilfsregister
	push	srsk							;sichere Hilfsregister auf Stack

	mov		temp3,temp1						;setze Zahl in Temp3(L) und Temp4(H)
	mov		temp4,temp2

;	ldi		temp1,zeile1
;	ldi		temp2,9
;	add		temp1,temp2	;Displayausgabe festlegen
;	call	lcd_command

			;hier beginnt ziffernausgabe

					;Vorzeichen setzen

	ldi		temp1,'0'
	sbrs	temp4,7							;wenn Bit 7=1(neg) berspringe nchste zeile
	jmp		lcd_number_Sram_wert_a

	ldi		temp1,'-'						;setze minuszeichen
	st		Y+,temp1
;	call	lcd_data
	neg		temp3
	neg		temp4							;negiere register um wert zu erhalten
	subi	temp4,1
	jmp		lcd_number_Sram_wert_b			;berspringe Lehrzeichen, weil Wert negativ
lcd_number_Sram_wert_a:
	ldi		temp1,' '						;setze Leerzeichen
	st		Y+,temp1
;	call	lcd_data
lcd_number_Sram_wert_b:

					;Zehntausender berechnen  
							      		  
	ldi 	wL,LOW(10000)
	ldi 	wH,HIGH(10000)
	ldi		temp1,'0'				;abzhlen wieviele Zehntausender in der Zahl enthalten sind
lcd_number_Sram_1:
    sub		temp3,wL				;10000 abziehen um Anzahl zu bestimmen
	sbc		temp4,wH					
	brcs	lcd_number_Sram_1a			;kleiner als null (Carry gesetzt?) -> gehe zur Ausgabe
	inc		temp1
	jmp		lcd_number_Sram_1                       
lcd_number_Sram_1a:						; die Zehntausenderstelle ausgeben
	cpi 	temp1,'0'               ; Compare r19 with 0
	brne 	lcd_number_Sram_1b
	ldi		temp1,' '
lcd_number_Sram_1b:
	mov		temp2,temp1
;	st		Y+,temp1                                           
;	call	lcd_data				;hier einschalten, wenn 10000er ausgegeben werden sollen
	add		temp3,wL	            ; 10000 wieder dazuzhlen, da die
    adc		temp4,wH             ; vorherhgehende Schleife 10000 zuviel abgezogen hat

					;Tausender berechnen  
							      		  
	ldi 	wL,LOW(1000)
	ldi 	wH,HIGH(1000)
	ldi		temp1,'0'				;abzhlen wieviele Zehntausender in der Zahl enthalten sind
lcd_number_Sram_2:
    sub		temp3,wL				;1000 abziehen um Anzahl zu bestimmen
	sbc		temp4,wH					
	brcs	lcd_number_Sram_2a			;kleiner als null (Carry gesetzt?) -> gehe zur Ausgabe
	inc		temp1
	jmp		lcd_number_Sram_2                               
lcd_number_Sram_2a:						; die Tausenderstelle ausgeben
	cpi 	temp1,'0'
	brne	lcd_number_Sram_2b
	cpi		temp2,' '
	brne	lcd_number_Sram_2b
	ldi		temp1,' '	            ; Compare r19 with 3                                
lcd_number_Sram_2b:
	mov		temp2,temp1
;	st		Y+,temp1
;	call	lcd_data				;hier einschalten, wenn 1000er Stelle ausgegeben werden soll
	add		temp3,wL	            ; 1000 wieder dazuzhlen, da die
    adc		temp4,wH             	; vorhergehende Schleife 1000 zuviel abgezogen hat
                                  		  
					;Hunderter berechnen  
							      		                                            
	ldi 	wL,LOW(100)
	ldi 	wH,HIGH(100)
	ldi		temp1,'0'				; abzhlen wieviele Hunderter in der Zahl enthalten sind
lcd_number_Sram_3:
    sub		temp3,wL				;100 abziehen um Anzahl zu bestimmen
	sbc		temp4,wH					
	brcs	lcd_number_Sram_3a
	inc		temp1
	jmp		lcd_number_Sram_3                                 
lcd_number_Sram_3a:					; die Hunderterstelle ausgeben
	cpi 	temp1,'0'               ; Compare r19 with 3
	brne 	lcd_number_Sram_3b
	cpi		temp2,' '
	brne	lcd_number_Sram_3b
	ldi		temp1,' '                                           
lcd_number_Sram_3b:
	st		Y+,temp1
;	call	lcd_data
	add		temp3,wL	            ; 100 wieder dazuzhlen, da die
    adc		temp4,wH             	; vorhergehende Schleife 100 zuviel abgezogen hat
                                          
					;Zehner berechnen  
							      		                                                                                     
	ldi		temp1,'0'				; abzhlen wieviele Zehner in der Zahl enthalten sind
lcd_number_Sram_4:
	subi	temp3,10
	brcs	lcd_number_Sram_4a
	inc		temp1
	jmp		lcd_number_Sram_4                                   
lcd_number_Sram_4a:					; die Zehnerstelle ausgeben
	st		Y+,temp1
;	call	lcd_data
	subi	temp3,-10               ; 10 wieder dazuzhlen, da die vorhergehende Schleife 10 zuviel abgezogen hat

					;Kommastelle setzen  
							      		        
	ldi		temp1,','				;Kommastelle setzen
	st		Y+,temp1
;	call	lcd_data

					;die brig gebliebenen Einer noch ausgeben

	ldi		temp1,'0'						
	add		temp1,temp3
	st		Y+,temp1
;	call	lcd_data

	pop		srsk
	out		SREG,srsk
	pop		wH
	pop		wL
	pop 	temp4
	pop		temp3
	pop		temp2
	pop		temp1
	ret


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
