; ADC INITIALISIEREN


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Register setzen:
;	MUX0-4 	in Register ADMUX  setzen
;	MUX5	in Register ADCSRB setzen
;	
;			[MUX5]	MUX4	MUX3	MUX2	MUX1	MUX0
;	ADC0	0		0		0		0		0		0
;	ADC1	0		0		0		0		0		1
;	ADC2	0		0		0		0		1		0
;	ADC3	0		0		0		0		1		1
;	ADC4	0		0		0		1		0		0
;	ADC5	0		0		0		1		0		1
;	ADC6	0		0		0		1		1		0
;	ADC7	0		0		0		1		1		1
;
;	ADC8	1		0		0		0		0		0
;	ADC9	1		0		0		0		0		1
;	ADC10	1		0		0		0		1		0
;	ADC11	1		0		0		0		1		1
;	ADC12	1		0		0		1		0		0
;	ADC13	1		0		0		1		0		1
;	ADC14	1		0		0		1		1		0
;	ADC15	1		0		0		1		1		1		
;
;	(ADMUX)			REFS1	REFS0
;	EXTERN			0		0
;	INTERN VCC		0		1
;	INTERN 1,1v		1		0
; 	INTERN 2,56V	1		1
;
;bei interner AREF immer mit ext. Kondensator zur Stabilisierung
;
;PRESCALER: -> SOLL ZWISCHEN 50 UND 200KHZ LIEGEN
;
;	(ADCSRA)
;	DIVISOR		ADPS2	ADPS1	ADPS0	BEI 16 MHZ
;	2			0		0		0		8MHZ
;	2			0		0		1		8MHZ
;	4			0		1		0		4MHZ
;	8			0		1		1		2MHZ
;	16			1		0		0		1MHZ
;	32			1		0		1		500KHZ
;	64			1		1		0		250KHZ
;	128			1		1		1		125KHZ
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
ADC_init:	
	push	temp1

	CLR		temp1					;temporres Register ablschen
	ldi     temp1, 	(0<<REFS1)|(0<<REFS0)|(0<<MUX4)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0)  
    STS     ADMUX,  temp1			; Referenzspannung AVcc int.(0,1) -> ext. (0,0) , Kanal 0, 
    ldi     temp1, 	(1<<ADATE)|(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)
    STS     ADCSRA, temp1			; 16 MHz / 128 = 125 kHz und einschalten
	ldi     temp1, 	(0<<MUX5)|(0<<ADTS2)|(0<<ADTS1)|(0<<ADTS0)
    STS     ADCSRB, temp1			; Eingnge 0-7 an / Free running mode
	SBR		temp1, 	(1<<ACD)			
	OUT		ACSR, 	temp1			; Analogcomparator ausschalten

	pop		temp1
	ret

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
adc_abfragen:
	push 	temp1
	push	temp2
	push	temp3
	in 		srsk,sreg
	push	srsk

	ldi		Ch,0					;Kanal-Register zurcksetzen
adc_Channel_set:	

	call	Channel_Set											

	lds		temp1,ADMUX				; lade ADMUX in Hilfsregister
	ldi		temp1,(0<<MUX4)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0)	;setze Kanle zu null
	add		temp1,Ch				; addiere Kanal zu Hilfsregister
	sts		ADMUX,temp1				; Speichere Hilfsregister in ADMUX
	call	delay5ms

;	cpi		Ch,8
;	sts		ADCSRB,temp2
;hier routine einfgen fr Kanle > 7		

	lds		temp1,ADCSRA			; lade register in Hilfsregister
	sbr		temp1,(1<<ADEN)|(1<<ADSC)			; setze bit adc-starten
	sts		ADCSRA,temp1			; lade hilfsregister in ADC-Statusregister
	clr		temp1					; lsche Hilfsregister 
;
	call	delay5ms
	call	delay5ms
	call	delay5ms
	call	delay5ms
;	call	delay5ms

get_adc:
	mov 	wL,trL
	mov 	wH,trH
	ldi 	trL,0					;Register fr Low-Wert zurcksetzten
	ldi 	trH,0					;Register fr High-Wert zurcksetzten

	ldi 	temp2,zaehler			;zhler fr schleife wird auf wert gesetzt (es wird X-mal gemessen)
	ldi 	temp3,pot_div			;Potenz-divisor wird gesetzt (es wird 2^X mal durch2 dividiert - Bits nach links geschoben)
	
	cli
lesen:
	lds 	temp1,adcl				;adcl auslesen
	add 	trL,temp1				;low zu hochrechnung addieren
	lds 	temp1,adch				;adch auslesen
	adc 	trH,temp1				;high zu hochrechnung addieren
	dec 	temp2					;zaehler um 1 verkleinern
	brne 	lesen
	sei					;wenn zs nicht 0, weiter lesen -> sonst Wert berechnen
	lds		temp1,ADCSRA			; lade register in Hilfsregister
	cbr		temp1,(0<<ADEN)			; ADC ausschalten
	sts		ADCSRA,temp1			; lade hilfsregister in ADC-Statusregister
	clr		temp1					; lsche Hilfsregister 

	cli
berechnen:
	lsr 	trH						;Ergebnis nach rechts schieben
	ror 	trL						;dto
	dec 	temp3					;Potenzwert dezimieren - X^2-Anzahl um einmal verringern
	brne 	berechnen				;wenn zd nicht null - weiter berechnen - sonst weiter im Text
	sei
;	rjmp	schreiben
ausgabe:
			
;ab hier anzeige -> diese Stelle ndern fr Ausgabe der Betriebsart an die Zimmer
	cli
	clc
; ab hier ausgabe an LED
	ldi 	wL,LOW(obergrenze)		;Low-Wert von Konstante in Register setzen
	ldi 	wH,HIGH(obergrenze)		;High-Wert von Konstante in Register setzen
	cp		trL,wL					;vergleiche low-byte mit low-register von konstante
	cpc 	trH,wH					;vergleiche high-byte mit high-register von konstante	
	brcc 	rot						;wenn Wert grer als Konstante (Carry gesetzt) zu Ausgang schalten springen
;
	ldi 	wL,LOW(Mitte)
	ldi 	wH,HIGH(Mitte)
	cp		trL,wL	
	cpc 	trH,wH	
	brcc 	gelb
;
	ldi 	wL,LOW(Untergrenze)
	ldi 	wH,HIGH(Untergrenze)
	cp		trL,wL	
	cpc 	trH,wH	
	brcc 	gruen		
;
	ldi 	wL,LOW(null)
	ldi 	wH,HIGH(null)
	cp		trL,wL	
	cpc 	trH,wH	
	brcc 	aus				
;
rot:
	sbi 	A,ledrot					;setze Bit fr LED direkt auf Ausgangsregister
	cbi 	A,ledgelb					;Lsche Bit fr LED direkt im Ausgangsregister
	cbi 	A,ledgruen					;Lsche Bit fr LED direkt im Ausgangsregister
	ldi 	trL,low(obergrenze)
	ldi 	trH,high(obergrenze)										
	jmp		schreiben

gelb:	
	cbi 	A,ledrot
	sbi 	A,ledgelb
	cbi 	A,ledgruen
	jmp 	schreiben

gruen:	
	cbi 	A,ledrot
	cbi 	A,ledgelb
	sbi 	A,ledgruen
	ldi 	trL,low(mitte)
	ldi 	trH,high(mitte)		
	jmp 	schreiben

aus:
	cbi 	A,ledrot
	cbi 	A,ledgelb
	cbi 	A,ledgruen
	ldi 	trL,low(offset)
	ldi 	trH,high(offset)	
	jmp 	schreiben

schreiben:
; ab hier ausgabe an LCD
	ldi 	temp1,low(offset)			;Offsetwert zum berechnen laden
	ldi 	temp2,high(offset)
;	cli
	sub 	trL,temp1					;Offsetwert vom gemessenen ergebnis abziehen (16-Bit)
	sbc 	trH,temp2
	mov		temp1,trL					;Ausgabewert in Temp1:2 laden fr Ausgabe and LCD
	mov 	temp2,trH
;	call 	lcd_number					;Zahl aus Registerpaar Temp1:2 ausgeben
	adiw	Y,ist
	call	lcd_number_Sram				;gleichen Wert in Sram speichern
;	ldi		temp3,0
;	call	Menu_Status
	sei
	inc		Ch							;nchsten Kanal einstellen
	cpi		Ch,Max_Ch					;maximale Kanal-Anzahl prfen
	breq	adc_abfragen_ende	
	jmp		adc_Channel_set
	
adc_abfragen_ende:

	pop		srsk
	out		sreg,srsk
	pop		temp3
	pop		temp2
	pop		temp1
	ret									;gehe zurck zum Hauptprogramm (Mainloop) -> eventuell in ADC-Routines verschieben


Channel_Set:
	ldi		YL,LOW(Channel)
	ldi		YH,HIGH(Channel)					
	st		Y,Ch						;schreibt den aktuellen Kanal in den SRAM

	ldi		ZL,LOW(Ch_Tab*2)
	ldi		ZH,HIGH(Ch_Tab*2)
	cli
	add		ZL,Ch
	adc		ZH,R0
	add		ZL,Ch
	adc		ZH,R0
	
	lpm		YL,Z+
	lpm		YH,Z
	sei

ret
